"use strict";
var assert = require("power-assert");
describe("Angular 1 TestService", function () {
    beforeEach(function () {
        angular.mock.module("ngMock", "app");
    });
    it("can instantiate", function (done) {
        inject(function (testService) {
            assert(!!testService);
            done();
        });
    });
    it("get(id) should return mocked TestModel", function (done) {
        inject(function ($httpBackend, testService) {
            $httpBackend.expectGET("").respond(200, { text: "mocked!" });
            testService.get("test").subscribe(function (resp) {
                assert(resp.text === "mocked!");
                done();
            }, function (error) {
                console.error(error);
                done();
            });
            $httpBackend.flush();
        });
    });
    it("post(data) should return mocked TestModel", function (done) {
        inject(function ($httpBackend, testService) {
            $httpBackend.expectPOST("/").respond(function (method, url, data, headers) { return [200, data, {}]; });
            testService.post({ text: "mocked!" }).subscribe(function (resp) {
                assert(resp.text === "mocked!");
                done();
            }, function (error) {
                console.error(error);
                done();
            });
            $httpBackend.flush();
        });
    });
});
