"use strict";
var core_1 = require("angular2-testing-lite/core");
var mocha_1 = require("angular2-testing-lite/mocha");
var http_1 = require("@angular/http");
var testing_1 = require("@angular/http/testing");
var core_2 = require("@angular/core");
var test_service_1 = require("./test.service");
var test_service_2 = require("../test.service");
var assert = require("power-assert");
mocha_1.describe("Angular 2 TestService", function () {
    mocha_1.beforeEach(function () {
        core_1.resetBaseTestProviders();
        core_1.getTestInjector().addProviders([
            http_1.BaseRequestOptions,
            testing_1.MockBackend,
            core_2.provide(http_1.Http, {
                useFactory: function (backend, options) {
                    return new http_1.Http(backend, options);
                }, deps: [testing_1.MockBackend, http_1.BaseRequestOptions]
            }),
            core_2.provide(test_service_2.TestService, { useClass: test_service_1.Ng2TestService })
        ]);
    });
    mocha_1.it("can instantiate", core_1.inject([test_service_2.TestService], function (service) {
        assert(!!service);
    }));
    mocha_1.it("get(id) should return mocked TestModel", function (done) {
        core_1.inject([testing_1.MockBackend, test_service_2.TestService], function (backend, service) {
            backend.connections.subscribe(function (c) {
                var resp = { text: "mocked!" };
                c.mockRespond(new http_1.Response(new http_1.ResponseOptions({
                    status: 200,
                    body: resp
                })));
            });
            service.get("test").subscribe(function (resp) {
                assert(!!resp);
                assert(resp.text === "mocked!");
                done();
            }, function (error) {
                assert(!error);
                done();
            });
        })(); // execute
    });
    mocha_1.it("post(data) should return mocked TestModel", function (done) {
        core_1.inject([testing_1.MockBackend, test_service_2.TestService], function (backend, service) {
            backend.connections.subscribe(function (c) {
                c.mockRespond(new http_1.Response(new http_1.ResponseOptions({
                    status: 200,
                    body: c.request.text(),
                })));
            });
            service.post({ text: "mocked!" }).subscribe(function (resp) {
                assert(!!resp);
                assert(resp.text === "mocked!");
                done();
            }, function (error) {
                assert(!error);
                done();
            });
        })(); // execute
    });
});
